using System;
using System.Collections.Generic;
using System.Text;

namespace OPP_Modeling
{
  /// <summary>
  /// Destructors usage
  /// - use destructors, if you need to free memory manualy
  /// - you dont have to implement destructor
  /// - implement IDisposable interface
  /// - iherited destructors are called in revers order to constructors
  /// - Forms use lots of ressources, so call dispoze
  /// </summary>
  public class Porsche : Car, IDisposable
  {
    ~Porsche() //destructor
    {
      Dispose(false);
    }

    public void Dispose() // used as idiom
    {
      Dispose(true);
      // This object will be cleaned up by the Dispose method.
      // Therefore, you should call GC.SupressFinalize to
      // take this object off the finalization queue
      // and prevent finalization code for this object
      // from executing a second time.
      GC.SuppressFinalize(this);
    }

    protected virtual void Dispose(bool disposing)
    {
      if (disposing)
      {
        // Objekt is already cleaned up by Dispose method
        // free managed ressources.
      }

      // free unmanaged ressources.
    }
  }
}
