using System;
using System.Collections.Generic;
using System.Text;

namespace OPP_Modeling
{
  /// <summary>
  /// Base class for all vehicles.
  /// Cant be initialized, is abstract.
  /// Inherits from object
  /// </summary>
  public abstract class Vehicle
  {
    #region fields
    private string name; //fields
    private string manufacturer;
    private int created;
    #endregion

    #region properties
    public int Created
    {
      get { return created; }
      set { created = value; }
    }

    public string Manufacturer
    {
      get { return manufacturer; }
      set { manufacturer = value; }
    }

    public string Name
    {
      get { return name; }
      set { name = value; }
    }

    #endregion

    //abstract - without implementation. Inherited type have to implement this member
    internal abstract string VehicleType();

    //like abstract + base implementation
    public virtual string VehicleTypeVirtual()
    {
      return "base virtual implementation";
    }

    //visible only in child types
    protected string VehicleTypeProtected()
    {
      return "parent implementation";
    }
  }
}
